package nucleus

import (
	"code.fbi.h-da.de/danet/gosdn/controller/interfaces/networkelement"
	"code.fbi.h-da.de/danet/gosdn/controller/store"
	"go.mongodb.org/mongo-driver/mongo"

	"github.com/google/uuid"
	log "github.com/sirupsen/logrus"
)

// NewNetworkElementStore returns a NetworkElementStore.
func NewNetworkElementStore(db *mongo.Database, pndUUID uuid.UUID) networkelement.Store {
	storeMode := store.GetStoreMode()
	log.Debugf("StoreMode: %s", storeMode)

	switch storeMode {
	case store.Database:
		return NewDatabaseNetworkElementStore(pndUUID, db)

	default:
		store := NewFilesystemNetworkElementStore()
		return store
	}
}
